package com.gct.tools.etlcamelhuge.routeconfig;

import org.apache.camel.Exchange;
import org.apache.camel.Message;
import org.apache.camel.Predicate;
import org.apache.camel.Processor;
import org.apache.camel.builder.RouteBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.ArrayList;
import java.util.HashMap;

/**
 * class name: CamelJDBCConfiguration
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/4/14 下午3:16
 */
@Configuration
public class CamelJDBCConfiguration {


    @Bean
    public RouteBuilder routeBuilder() {
        ArrayList<HashMap<String, Object>> hashMaps = new ArrayList<>();
        return new RouteBuilder() {
            @Override
            public void configure() throws Exception {
                from("timer://foo?period=1000")
                .routeId("jdbc-pg-?")
                .setHeader("prod_time_ctl", constant("2021-02-27 10:00:00.000000"))
                 //.setBody(constant("select * from centralbase.cb_temp_well_mech_runtime where prod_date= :prod_time_ctl "))
                .setBody(simple("select * from centralbase.cb_temp_well_mech_runtime where prod_date= :?prod_time_ctl ::timestamp "))
                .log("select body :${body}")
                .to("jdbc:centralbase?useHeadersAsParameters=true")
                .tracing()
                //via transform
                .transform()
                    .body(result -> {
                        ArrayList<HashMap<String, Object>> list = hashMaps.getClass().cast(result);
                        log.info("The data count:{}", list.toString());
                        return list;
                    })
                //split data to one by one
                .split(body()).process(exchange -> {
                    Message in = exchange.getIn();
                    HashMap<String, Object> aRow = in.getBody(HashMap.class);
                    log.info("The data count2222:{}", aRow.toString());
                })
                .log("ok?").setHeader("dddd", constant("ssss"))
                /*.process().message(message -> {
                    log.info("message:{}", message.getHeader("dddd"));
                    ArrayList<HashMap<String, Object>>  body = message.getBody(ArrayList.class);
                    log.info("body::::{}",body.toString());
                })*/
                /*.process(exchange -> {
                    Message in = exchange.getIn();
                    ArrayList<HashMap<String, Object>> aRow = in.getBody(ArrayList.class);
                    log.info("The data count3333:{}", aRow.toString());
                })*/
                //create "insert sql" with parameters
               .setBody(simple("insert into dgns_gtbaseparam(wellname,recivetime,sgt) values('${body[well_id]}','${body[prod_date]}' :: timestamp,'${body[sgt]}')"))
                //now for test
                //.setBody(simple("insert into dgns_gtbaseparam(wellname,recivetime,sgt) values('${body[well_id]}',now(),'${body[sgt]}')"))
                //look up the insert sql
                .process().message(message -> {
                    log.info("The insert sql {}", message.getBody(String.class));
                })
                //try test
                .doTry()
                    .to("jdbc:diagnosis").log("insert completed")

                .doCatch(Throwable.class)
                    .log("primary key already exited,insert failed")
                    //"if" statement test
                    /*.choice()
                        .when(exchange -> {
                            return exchange.getException() != null;
                           *//* if (exchange.getException() != null) {
                                log.error(exchange.getException().getMessage());
                                return exchange.getException().getMessage().contains("already");
                            }
                            return false;*//*
                        }).log("primary key already exited,insert failed")
                        .otherwise().log("insert completed")
                    .endChoice()*/
                .end();

            }

            ;


        };
    }
}
